# -*- coding: utf-8 -*-
"""
Created on Thu Oct 19 2017
Modified on July 20 2020

@author: johana
"""
# Libraries
from definitions import *
from Features import * # Library  with the functions which extract features
import time

# Global variables
COOR = 1 # Number of sample

# Image capture room 
base = 'imaA1.jpg'
filename = base

    
# Internal Functions
def A1sensor(): ## Capture data
    # Example: capture information from a camera
    # Tethering
    retval = os.system("gphoto2 --capture-image-and-download")
    if not retval:
        os.system("mv capt0000.jpg " + filename)
        time.sleep(1)
        return 0
    else:
        one.log_info("Unable to capture image sensor")
        return 1


def VSfeatures(filename):
    # Example extract a set of features
    ima = load_image_array(filename) # Read the file of the image captured
    return imagefeature(ima)

def runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB):
    local_dir = os.path.dirname(__file__)
    Net_path0 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-A10')
    Net_path1 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-A11')
    inputnetI, inputnetG, tam = one.IS_Inputs()
    return a_DMS('A1',Net_path0, Net_path1, inputnetI,inputnetG,tam,10,fsinB,fsouB,frulB)

# Agent definition
one = run_agent('A1', base=ModelAgent)
one.phy_address(1,add1)
# Time to predefine the conecctions among agents
time.sleep(WAITIME)
sam = 0
data = ([])
data1 = ([])
data2 = ([])
data3 = ([])
data4 = ([])
data5 = ([])
data6 = ([])
inicio = time.time()

# Preload logic rules if it is required
if DMS_CUN == 'GFS' or DMS_CUN == 'ALL':
    fsinB,fsouB,frulB = a_DMS_FL_Rules('A1')
else:
    fsinB,fsouB,frulB = 0.0,0.0,0.0,0.0,0.0,0.0

while one.readstop() == 0:
    
    # Sensor capture
    a = 1
    while a == 1:
        a = one.sensor_read(A1sensor)

    # Feature extractor
    one.extract_features(A1features,filename)

    # Intelligent system 
    uncl,uncg = runIS(fsinB,fsouB,frulB)
    one.info([0,uncl[0],0])
    
    #Save data
    delta = time.time()-inicio
    if DMS_CUN == 'ALL':
        tem = np.array([delta,COOR,mine,uncl[0],uncg[0]])
        data1 = np.append(data1,tem)
        tem = np.array([delta,COOR,mine,uncl[0],uncg[1]])
        data2 = np.append(data2,tem)
        tem = np.array([delta,COOR,mine,uncl[0],uncg[2]])
        data3 = np.append(data3,tem)
        tem = np.array([delta,COOR,mine,uncl[0],uncg[3]])
        data4 = np.append(data4,tem)
        tem = np.array([delta,COOR,mine,uncl[0],uncg[4]])
        data5 = np.append(data5,tem)
        tem = np.array([delta,COOR,mine,uncl[0],uncg[5]])
        data6 = np.append(data6,tem)
    else:
        tem = np.array([delta,COOR,mine,uncl[0],uncg[0]])
        data = np.append(data,tem)
    sam = sam+1

if DMS_CUN == 'ALL':
    data1 = np.reshape(data1, [sam,5])
    np.savetxt('Test/'+str(int(COOR)+'_A1_NEAT_'+DMS_NBP+'.csv',data1,delimiter=',')
    data2 = np.reshape(data2, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_GFS_'+DMS_NBP+'.csv',data2,delimiter=',')
    data3 = np.reshape(data3, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_MEAN_'+DMS_NBP+'.csv',data3,delimiter=',')
    data4 = np.reshape(data4, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_MEDIAN_'+DMS_NBP+'.csv',data4,delimiter=',')
    data5 = np.reshape(data5, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_MAX_'+DMS_NBP+'.csv',data5,delimiter=',')
    data6 = np.reshape(data6, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_VOTE_'+DMS_NBP+'.csv',data6,delimiter=',')
else:
    data = np.reshape(data, [sam,5])
    np.savetxt('Test/'+str(int(COOR))+'_A1_'+DMS_CUN+'_'+DMS_NBP+'.csv',data,delimiter=',')
    
one.__del__()